From news Sun Dec 28 04:27:58 91 
From: eps@futon.SFSU.EDU (Eric P. Scott)
Subject: Enabling sound access from the UNIX console under 2.x

Am I the only one who finds it annoying that sound stuff doesn't
work when logged in on the true console (i.e. no Window Server)?

This _probably_ needs to be run as root.

					-=EPS=-
-------
/*
 * knowsound: register sound port with Bootstrap Server
 *
 * cc -o knowsound -s -O -bsd -object knowsound.c
 */

#include <stdio.h>
#include <sys/file.h>
#include <sys/ioctl.h>
#include <mach.h>
#include <sys/message.h>
#include <servers/bootstrap.h>
#include <sound/sounddriver.h>
#include <nextdev/snd_msgs.h>

main(argc, argv)
int argc;
char *argv[];
{
	int d;
	kern_return_t k;
	msg_header_t msg;

	if (argc!=1) {
		(void)fprintf(stderr, "Usage: %s\n", *argv);
		exit(1);
	}
	if (bootstrap_look_up(bootstrap_port, "sound",
		&msg.msg_remote_port)==BOOTSTRAP_SUCCESS) {
		(void)fputs("sound port already registered\n", stderr);
		exit(1);
	}
	if ((d=open("/dev/sound", O_RDONLY, 0))<0) {
		perror("/dev/sound");
		exit(1);
	}
	if (ioctl(d, SOUNDIOCDEVPORT, thread_reply())<0) {
		(void)close(d);
		perror("SOUNDIOCDEVPORT");
		exit(1);
	}
	bzero((char *)&msg, sizeof msg);
	msg.msg_simple=1;
	msg.msg_size=24;
	msg.msg_local_port=thread_reply();
	if ((k=msg_receive(&msg, MSG_OPTION_NONE, 0))!=RCV_SUCCESS) {
		(void)close(d);
		mach_error("msg_receive failed", k);
		exit(1);
	}
	(void)close(d);
	if (msg.msg_id!=SND_MSG_RET_DEVICE) {
		(void)fprintf(stderr,
			"Sound driver returned %d message???\n", msg.msg_id);
		exit(1);
	}
	if ((k=bootstrap_register(bootstrap_port, "sound",
		msg.msg_remote_port))!=BOOTSTRAP_SUCCESS) {
		mach_error("bootstrap_register failed", k);
		exit(1);
	}
	exit(0);
}


